﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace $safeprojectname$
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        // Initialize the card.
        int CardAddress;
        // General procedures.
        [DllImport("k8061.dll")]
        public static extern int OpenDevice();

        [DllImport("k8061.dll")]
        public static extern void CloseDevices();

        [DllImport("k8061.dll")]
        public static extern void CloseDevice(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern bool PowerGood(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern bool Connected(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern void ReadVersion(int CardAddress, int[] Buffer);

        // Analogue to Digital converter procedures.
        [DllImport("k8061.dll")]
        public static extern int ReadAnalogChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern void ReadAllAnalog(int CardAddress, int[] Buffer);

        // Digital to Analogue conversion procedures.
        [DllImport("k8061.dll")]
        public static extern void OutputAnalogChannel(int CardAddress, int Channel, int Data);

        [DllImport("k8061.dll")]
        public static extern void OutputAllAnalog(int CardAddress, int[] Buffer);

        [DllImport("k8061.dll")]
        public static extern void ClearAnalogChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern void ClearAllAnalog(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern void SetAnalogChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern void SetAllAnalog(int CardAddress);

        // PWM Output procedure.
        [DllImport("k8061.dll")]
        public static extern void OutputPWM(int CardAddress, int Data);

        // Digital Output procedures.
        [DllImport("k8061.dll")]
        public static extern void OutputAllDigital(int CardAddress, int Data);

        [DllImport("k8061.dll")]
        public static extern void ClearDigitalChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern void ClearAllDigital(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern void SetDigitalChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern void SetAllDigital(int CardAddress);

        // Digital input procedures and functions.
        [DllImport("k8061.dll")]
        public static extern bool ReadDigitalChannel(int CardAddress, int Channel);

        [DllImport("k8061.dll")]
        public static extern int ReadAllDigital(int CardAddress);

        // Readback procedures and functions.
        [DllImport("k8061.dll")]
        public static extern int ReadBackDigitalOut(int CardAddress);

        [DllImport("k8061.dll")]
        public static extern void ReadBackAnalogOut(int CardAddress, int[] Buffer);

        [DllImport("k8061.dll")]
        public static extern int ReadBackPWMOut(int CardAddress);


        private void button1_Click(object sender, EventArgs e)
        {
            int a = OpenDevice();
            switch (a)
            {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                    label2.Text = "Card " + a.ToString() + " connected";
                    CardAddress = a;
                    break;
                case -1:
                    label2.Text = "All cards connected.";
                    break;
                case -2:
                    label2.Text = "Card not found.";
                    break;
            }
            timer2.Enabled = true;
            updateCardNumber();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Load cards.
        }
        private void Form1_FormClosed(Object sender, FormClosedEventArgs e)
        {
            CloseDevices();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // Every 500 milliseconds, the following script will be executed.
            // Get the date and time for the current moment, adjusted to the local time zone.
            String timeStr = "" + DateTime.Now;
            label3.Text = timeStr;
            DateTime dt = DateTime.Now;
            String[] format = {
                // d returns: month/day/fullyear eg: 12/30/2010
                // D returns: weekday calendarday monthname year eg:Thursday 30 December 2010
                // f returns: D+ hour:mintes eg:Thursday 30 December 2010 19:56
                // F returns: f+ seconds eg: Thursday 30 December 2010 19:56:25
                // g returns: d + hour:minutes eg: 12/30/2010 19:56
                // G returns: g + seconds eg: 12/30/2010 19:56:27
                // m returns: monthname/calendarday eg: December30
                // mm returns: minutes eg: 56
                // r returns for example Thu, 30 Dec 2010 19:56:27 GMT
                // s returns for example 2010-12-30T19:56:27
                // ss returns the seconds eg: 27
                // t returns: hours:minutes eg: 19:56
                // tt returns AM or PM
                // T returns: hour:minutes:seconds
                // U returns UTC time for example Thursday,30December2010 18:56:27
                // y returns: year and monthname eg: 2010 December
                // yyyy returns: year eg: 2010
                // ddd returns the first 3 characters of the dayname eg: Thu
                // MMMM returns the full monthname eg: December
                // MMM returns the first 3 characters of the monthname eg: Dec
           "HH:mm:ss"
        };
            String date;
            int i = 0;
            date = dt.ToString(format[i], System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label3.Text = String.Concat(date);
            String dayName = "dddd";
            String dayNameStr = dt.ToString(dayName, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            String dayStr = "ddd";
            String dayWeekStr = dt.ToString(dayStr, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label4.Text = dayWeekStr.ToString();
            if (dayWeekStr == "Sun")
            {
                label24.Text = "Sunday";
                // Next code comes here.

            }
            if (dayWeekStr == "Mon")
            {
                label24.Text = "Monday";
                // Next code comes here.

            }
            if (dayWeekStr == "Tue")
            {
                label24.Text = "Tuesday";
                // Next code comes here.

            }
            if (dayWeekStr == "Wed")
            {
                label24.Text = "Wednesday";
                // Next code comes here.

            }
            if (dayWeekStr == "Thu")
            {
                label24.Text = "Thursday";
                // Next code comes here.

            }
            if (dayWeekStr == "Fri")
            {
                label24.Text = "Friday";
                // Next code comes here.

            }
            if (dayWeekStr == "Sat")
            {
                label24.Text = "Saturday";
                // Next code comes here.
            }
            // Convert the seconds to a number to set the height of a pictureBox12.
            String seconds = "ss";
            String secStr = dt.ToString(seconds, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            int s = dt.Second;
            pictureBox12.Width = s  * 2;
            // Convert the minutes to a number to set the height of pictureBox11.
            String minutes = "mm";
            String minStr = dt.ToString(minutes, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            int m = dt.Minute;
            pictureBox11.Width = m * 2;
            label26.Text = minStr;
            // Convert the hours to a number to set the height of the pictureBox10.
            String hours = "HH";
            String hourStr = dt.ToString(hours, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            int h = dt.Hour;
            label25.Text = hourStr;
            if (h > 0)
            {
                pictureBox10.Width = (5 * (h + 1));
            }
            if (h <= 0)
            {
                pictureBox10.Width = 0;
            }
            startProgram();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            // Check for errors.
            int[] Buffer = new int[8];
            int b;
            richTextBox1.Text = "";
            if (PowerGood(CardAddress))
            {
                label6.Text = "CPU OK";
            }
            else
            {
                label6.Text = "";
                richTextBox1.Text = "CPU Fail";
                pictureBox1.Visible = true;
                groupBox3.Text = "!! Warning !!";
            }
            if (Connected(CardAddress))
            {
                label5.Text = "USB Connected";
            }
            else
            {
                label5.Text = "";
                richTextBox1.Text += "\r\nUSB Disconnected";
                pictureBox1.Visible = true;
                groupBox3.Text = "!! Warning !!";
            }
            b = ReadAllDigital(CardAddress);
            ReadAllAnalog(CardAddress, Buffer);
            if (richTextBox1.Text == "")
            {
                pictureBox1.Visible = false;
                groupBox3.Text = "Running...";
                groupBox3.ForeColor = System.Drawing.Color.DarkGreen;
            }
            else
            {
                groupBox3.ForeColor = System.Drawing.Color.Red;
            }
            updateCardNumber();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SetAllDigital(CardAddress);
            // Make the function visible.
            checkBox12.Checked = true;
            checkBox13.Checked = true;
            checkBox14.Checked = true;
            checkBox15.Checked = true;
            checkBox16.Checked = true;
            checkBox17.Checked = true;
            checkBox18.Checked = true;
            checkBox19.Checked = true;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ClearAllDigital(CardAddress);
            // Clear all digital checkBoxes.
            checkBox12.Checked = false;
            checkBox13.Checked = false;
            checkBox14.Checked = false;
            checkBox15.Checked = false;
            checkBox16.Checked = false;
            checkBox17.Checked = false;
            checkBox18.Checked = false;
            checkBox19.Checked = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SetAllAnalog(CardAddress);
            hScrollBar2.Value = 255;
            label16.Text = "255";
            hScrollBar3.Value = 255;
            label17.Text = "255";
            hScrollBar4.Value = 255;
            label18.Text = "255";
            hScrollBar5.Value = 255;
            label19.Text = "255";
            hScrollBar6.Value = 255;
            label20.Text = "255";
            hScrollBar7.Value = 255;
            label21.Text = "255";
            hScrollBar8.Value = 255;
            label22.Text = "255";
            hScrollBar9.Value = 255;
            label23.Text = "255";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ClearAllAnalog(CardAddress);
            hScrollBar2.Value = 0;
            label16.Text = "0";
            hScrollBar3.Value = 0;
            label17.Text = "0";
            hScrollBar4.Value = 0;
            label18.Text = "0";
            hScrollBar5.Value = 0;
            label19.Text = "0";
            hScrollBar6.Value = 0;
            label20.Text = "0";
            hScrollBar7.Value = 0;
            label21.Text = "0";
            hScrollBar8.Value = 0;
            label22.Text = "0";
            hScrollBar9.Value = 0;
            label23.Text = "0";
        }

        private void button6_Click(object sender, EventArgs e)
        {
            CloseDevices();
        }

        // PWM output.
        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            label15.Text = hScrollBar1.Value.ToString();
            OutputPWM(CardAddress, hScrollBar1.Value);
        }

        // DAC 1.
        private void hScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            label16.Text = hScrollBar2.Value.ToString();
            OutputAnalogChannel(CardAddress, 1, hScrollBar2.Value);
        }

        // DAC 2.
        private void hScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            label17.Text = hScrollBar3.Value.ToString();
            OutputAnalogChannel(CardAddress, 2, hScrollBar3.Value);
        }

        // DAC 3.
        private void hScrollBar4_Scroll(object sender, ScrollEventArgs e)
        {
            label18.Text = hScrollBar4.Value.ToString();
            OutputAnalogChannel(CardAddress, 3, hScrollBar4.Value);
        }

        // DAC 4.
        private void hScrollBar5_Scroll(object sender, ScrollEventArgs e)
        {
            label19.Text = hScrollBar5.Value.ToString();
            OutputAnalogChannel(CardAddress, 4, hScrollBar5.Value);
        }

        // DAC 5.
        private void hScrollBar6_Scroll(object sender, ScrollEventArgs e)
        {
            label20.Text = hScrollBar6.Value.ToString();
            OutputAnalogChannel(CardAddress, 5, hScrollBar6.Value);
        }

        // DAC 6.
        private void hScrollBar7_Scroll(object sender, ScrollEventArgs e)
        {
            label21.Text = hScrollBar7.Value.ToString();
            OutputAnalogChannel(CardAddress, 6, hScrollBar7.Value);
        }

        // DAC 7.
        private void hScrollBar8_Scroll(object sender, ScrollEventArgs e)
        {
            label22.Text = hScrollBar8.Value.ToString();
            OutputAnalogChannel(CardAddress, 7, hScrollBar8.Value);
        }

        // DAC 8.
        private void hScrollBar9_Scroll(object sender, ScrollEventArgs e)
        {
            label23.Text = hScrollBar9.Value.ToString();
            OutputAnalogChannel(CardAddress, 8, hScrollBar9.Value);
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox12.Checked == true)
            {
                SetDigitalChannel(CardAddress, 1);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 1);
            }
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox13.Checked == true)
            {
                SetDigitalChannel(CardAddress, 2);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 2);
            }
        }

        private void checkBox14_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox14.Checked == true)
            {
                SetDigitalChannel(CardAddress, 3);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 3);
            }
        }

        private void checkBox15_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox15.Checked == true)
            {
                SetDigitalChannel(CardAddress, 4);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 4);
            }
        }

        private void checkBox16_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox16.Checked == true)
            {
                SetDigitalChannel(CardAddress, 5);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 5);
            }
        }

        private void checkBox17_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox17.Checked == true)
            {
                SetDigitalChannel(CardAddress, 6);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 6);
            }
        }

        private void checkBox18_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox18.Checked == true)
            {
                SetDigitalChannel(CardAddress, 7);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 7);
            }
        }

        private void checkBox19_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox19.Checked == true)
            {
                SetDigitalChannel(CardAddress, 8);
            }
            else
            {
                ClearDigitalChannel(CardAddress, 8);
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            // Update cardaddress.
            updateCardNumber();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            // Update cardaddress.
            updateCardNumber();
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            // Update cardaddress.
            updateCardNumber();
        }
        private void updateCardNumber()
        {
            label5.Text = "";
            label6.Text = "";
             if (checkBox1.Checked == true)
             {
                 if (checkBox2.Checked == true && checkBox3.Checked == true)
                 {
                     CardAddress = 0;
                 }
                 if (checkBox2.Checked == false && checkBox3.Checked == true)
                 {
                     CardAddress = 2;
                 }
                 if (checkBox2.Checked == true && checkBox3.Checked == false)
                 {
                     CardAddress = 4;
                 }
                 if (checkBox2.Checked == false && checkBox3.Checked == false)
                 {
                     CardAddress = 6;
                 }
             }
             if (checkBox1.Checked == false)
             {
                 if (checkBox2.Checked == true && checkBox3.Checked == true)
                 {
                     CardAddress = 1;
                 }
                 if (checkBox2.Checked == false && checkBox3.Checked == true)
                 {
                     CardAddress = 3;
                 }
                 if (checkBox2.Checked == true && checkBox3.Checked == false)
                 {
                     CardAddress = 5;
                 }
                 if (checkBox2.Checked == false && checkBox3.Checked == false)
                 {
                     CardAddress = 7;
                 }
             }
            int[] Buffer = new int[8];
            richTextBox1.Text = "";
            if (PowerGood(CardAddress))
            {
                label6.Text = "CPU OK";
                label2.Text = "Card " + CardAddress.ToString() + " connected";
            }
            else
            {
                label6.Text = "";
                richTextBox1.Text = "CPU Fail";
                pictureBox1.Visible = true;
                groupBox3.Text = "!! Warning !!";
                label2.Text = "Error on cardn° " + CardAddress + " .";
            }
            if (Connected(CardAddress))
            {
                label5.Text = "USB Connected";
                label2.Text = "Card " + CardAddress.ToString() + " connected";
            }
            else
            {
                label5.Text = "";
                richTextBox1.Text += "\r\nUSB Disconnected";
                pictureBox1.Visible = true;
                groupBox3.Text = "!! Warning !!";
                label2.Text = "Error on cardn° " + CardAddress + " .";
            }
            if (richTextBox1.Text == "")
            {
                pictureBox1.Visible = false;
                groupBox3.Text = "Running...";
                groupBox3.ForeColor = System.Drawing.Color.DarkGreen;
            }
            else
            {
                groupBox3.ForeColor = System.Drawing.Color.Red;
            }
            ReadAllAnalog(CardAddress, Buffer);
            // pictureBox2.Width = Buffer[0];
            label7.Text = Buffer[0].ToString();
            //pictureBox3.Width = Buffer[1];
            label8.Text = Buffer[1].ToString();
            pictureBox4.Width = Buffer[2];
            label9.Text = pictureBox4.Width.ToString();
            pictureBox5.Width = Buffer[3];
            label10.Text = pictureBox5.Width.ToString();
            pictureBox6.Width = Buffer[4];
            label11.Text = pictureBox6.Width.ToString();
            pictureBox7.Width = Buffer[5];
            label12.Text = pictureBox7.Width.ToString();
            pictureBox8.Width = Buffer[6];
            label13.Text = pictureBox8.Width.ToString();
            pictureBox9.Width = Buffer[7];
            label14.Text = pictureBox9.Width.ToString();
            int b = ReadAllDigital(CardAddress);
            checkBox4.Checked = (b & 1) > 0;
            checkBox5.Checked = (b & 2) > 0;
            checkBox6.Checked = (b & 4) > 0;
            checkBox7.Checked = (b & 8) > 0;
            checkBox8.Checked = (b & 16) > 0;
            checkBox9.Checked = (b & 32) > 0;
            checkBox10.Checked = (b & 64) > 0;
            checkBox11.Checked = (b & 128) > 0;
            updateAnalogueChannels();
        }
        // Next code comes here.
        private void startProgram()
        {
            if (label25.Text == "00" && label26.Text == "27")
            {
                if (checkBox12.Checked == false)
                {
                    SetDigitalChannel(0, 1);
                    checkBox12.Checked = true;
                }
            }
            if (label25.Text == "00" && label26.Text == "28")
            {
                if (checkBox12.Checked == true)
                {
                    ClearDigitalChannel(0, 1);
                    checkBox12.Checked = false;
                }
            }
        }
        private void updateAnalogueChannels()
        {
            // 2.75 Volt = 275 as value.
            // AD1 = 0.18V = 18 as readout.
            // 263 = 18.6 °C.
            // max = 70°C or 0.7V.
            // 14.13978494 = 1°C.
            // 255/70 = 3.64.
            // decimal a = 3.64m;
            int a;
            int val1 = ReadAnalogChannel(0, 1);
            decimal b = 3.64m;
            decimal ba = 14.13978494m;
            a = decimal.ToInt32(ba * b);
            pictureBox2.Width = a;
            label7.Text = val1.ToString();
            label27.Text = "" + val1 / ba + " °C";

            // AD2 = 2V max or 98 millivolt gives a value of 20 = 4.9 = 1 millivolt.
            // The maximum value = 2Volt or a value of 255. 2000/4.9 = 408.
            // 2 volt = 255 1millivolt = 255/2000 = 0.1275.
            decimal r = 4.9m;
            decimal val = ReadAnalogChannel(0, 2);
            label29.Text = "" + val * r + " millivolt";
            int d;
            decimal c = 0.1275m;
            d = decimal.ToInt32(val * c);
            pictureBox3.Width = d;
        }
    }
}
